' ########################################################################
' # RF12-Test Bascom
' # by Holli
' # Pollin Funk-AVR Board - RFM12 on board
' # reading FIFO via clocking SCK/SDO while FFIT high (IRQ) and nFFS set low
' # 1 bit FIFO - read 1 bit at a time
' # works only with soft-SPI because of SPI bitbanging
' ########################################################################


$regfile = "m32def.dat"
$hwstack = 32
$swstack = 10
$framesize = 40
$crystal = 8000000
$baud = 19200
Baud = 19200

Config Portd.2 = Input
Nirq Alias Pind.2

Config Pind.3 = Input
Ffit Alias Pind.3

Sdo Alias Pinb.6                                            'angepasst
Sck Alias Portb.7                                           'angepasst

Config Portb.3 = Output
Fsk Alias Portb.3                                           'angepasst
Set Fsk

Led Alias Portd.5
Config Portd.5 = Output                                     'LED zur Kontrolle

Dim Count As Byte
Dim Count2 As Byte
Dim Temp As Byte
Dim Rx(32) As Byte
Dim Cmd(2) As Byte
Dim Fifo(4) As Byte

Declare Sub Rf_cmd(byval Wert As Word)



'Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 64 , Noss = 0 , Spiin = 0
Config Spi = Soft , Din = Pinb.6 , Dout = Portb.5 , Ss = Portb.4 , Clock = Portb.7 , Spiin = 0

'init the spi
Spiinit

Waitms 100

Toggle Led

Call Rf_cmd(&H0000)                                         'read status
Call Rf_cmd(&Hc0e0)                                         'low battery, clock 10 MHz
Call Rf_cmd(&H80d7)                                         'Configuration: 433 MHzband, 12pf
Call Rf_cmd(&H82d8)                                         'power management: enable er, ebb, es, ex
Call Rf_cmd(&Hc2ac)                                         'data filter command
Call Rf_cmd(&Ha686)                                         'Frequency: 434,175 MHz
'Call Rf_cmd(&Hc603) 'Datarate: 86,2 kbit
'Call Rf_cmd(&Hc605)  'Datarate: 57,4 kbit
'Call Rf_cmd(&Hc608)  'Datarate: 38,4 kbit
Call Rf_cmd(&Hc611)                                         'Datarate: 19,2 kbit
'Call Rf_cmd(&Hc623)    'Datarate: 9,6 kbit
'Call Rf_cmd(&Hc646) 'Datarate: 4,8 kbit
'Call Rf_cmd(&Hc691)  'Datarate: 2,4 kbit
Call Rf_cmd(&H94a1)                                         'receiver setting: 134kHz, -97dbm
Call Rf_cmd(&Hc2ac)                                         'data filter:
Call Rf_cmd(&Hc483)                                         'AFC:
Call Rf_cmd(&H9850)                                         'TX control
Call Rf_cmd(&He000)                                         'wake-up
Call Rf_cmd(&Hc800)                                         'low duty-cycle
Call Rf_cmd(&Hca11)                                         'set FIFO IT to 1 bit
Call Rf_cmd(&Hca13)                                         'enable FIFO
Call Rf_cmd(&H0000)                                         'read status



Do

Toggle Led

'Bitwait Ffit , Set                                          'use FFIT or nIRQ
Bitwait Nirq , Reset

Reset Fsk                                                   'set FSK low

For Count = 1 To 9
   For Count2 = 1 To 8                                      'read 1 byte
      'Bitwait Ffit , Set                                    'use FFIT or nIRQ
      Bitwait Nirq , Reset
      Set Sck                                               'clock SCK-Pin high
      Shift Rx(count) , Left                                'fill 1 byte
      Rx(count) = Rx(count) + Sdo                           'read SDO-Pin
      Reset Sck                                             'clock SCK-Pin low
   Next
Next
Set Fsk

Call Rf_cmd(&H0000)                                         'read status
Call Rf_cmd(&Hca11)                                         'Reset FIFO
Call Rf_cmd(&Hca13)                                         'enable FIFO

For Count = 1 To 32
    Print Chr(rx(count)) ;
Next Count
Print


Loop
End



Sub Rf_cmd(byval Wert As Word)
   Cmd(2) = Wert And 255
   Shift Wert , Right , 8
   Cmd(1) = Wert
   Spiout Cmd(1) , 2
End Sub